#!/usr/bin/python3
# ******************************************************************************
# Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
# licensed under the Mulan PSL v2.
# You can use this software according to the terms and conditions of the Mulan PSL v2.
# You may obtain a copy of Mulan PSL v2 at:
#     http://license.coscl.org.cn/MulanPSL2
# THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY OR FIT FOR A PARTICULAR
# PURPOSE.
# See the Mulan PSL v2 for more details.
# ******************************************************************************/
import json

from flask import Flask
from flask_restful import Api, reqparse, Resource, abort

employee = {
    "1": {"name": "a", "age": 24, "sex": "man"},
    "2": {"name": "b", "age": 25, "sex": "man"},
    "3": {"name": "c", "age": 26, "sex": "woman"}
}

app = Flask("employ")
api = Api(app)

parse = reqparse.RequestParser()
parse.add_argument('info')


class EmployInfo(Resource):
    @staticmethod
    def _name_not_in_employee(employ_id):
        if employ_id not in employee:
            abort(404, content="name not exist")

    def get(self, employ_id):
        self._name_not_in_employee(employ_id)
        return employee[employ_id], 200

    def put(self, employ_id):
        self._name_not_in_employee(employ_id)
        args = parse.parse_args()
        employ_info = args.get('info').replace('\'', '\"')
        employee[employ_id] = json.loads(employ_info)
        print(type(args.get('info')))
        return employee[employ_id], 200

    def delete(self, employ_id):
        self._name_not_in_employee(employ_id)
        employee.pop(employ_id)
        return 200


class EmployeeInfos(Resource):
    @staticmethod
    def post():
        args = parse.parse_args()
        new_id = int(max(employee.keys())) + 1
        employ_info = args.get('info').replace('\'', '\"')
        employee[str(new_id)] = json.loads(employ_info)
        return employee[str(new_id)], 201

    def get(self):
        return "hyz", 200


if __name__ == '__main__':
    # api.add_resource(EmployInfo, '/employee_info/<employ_id>')
    api.add_resource(EmployeeInfos, '/')
    app.run(host='192.168.0.16', port=8888)
